<template>
  <div class="d-flex flex-col flex-jc-start w-100 text-left">
    <p class="text-pink text-bold text-smaller mt-5 ph-3">ACCOUNT SETTINGS</p>
    <Error class="mt-3 mb-5 mh-2 flex-noshrink" v-if="updatingInfoError" :error.sync="updatingInfoError" round/>
    <!-- Remove toggle and use Input, use v-model instead of :value, remove validate -->
    <form class="d-flex flex-col" @submit="updateInformation">
      <ul class="mt-1 mb-4">
        <li>
          <span>
            Email
            <input :placeholder="user.email" v-model="email" class="flex-1 text-right"/>
          </span>
        </li>
        <li>
          <span>
            Username
            <input :placeholder="user.username" v-model="username" class="flex-1 text-right"/>
          </span>
        </li>
        <li>
          <span class="w-100 text-left pointer" @click="changePass = !changePass">
            Password
          </span>
          <!-- remove alwaysreset -->
          <div v-if="changePass" class="d-flex flex-row flex-nowrap pv-1 mt-1">
            <span class="mr-1">Old password</span>
            <input type="password" class="flex-1 text-right"
              value="password" v-model="oldPassword"/>
          </div>

          <div v-if="changePass" class="d-flex flex-row flex-nowrap pv-1">
            <span class="mr-1">New password</span>
            <input type="password" class="flex-1 text-right"
              value="password" v-model="newPassword"/>
          </div>
        </li>
        <li>
        <input type="checkbox" v-model="email_notify">
          <span>
            Email notifications
          </span>
        </li>
        <li>
        <input type="checkbox" v-model="location_enabled">
          <span>
            Use location
          </span>
        </li>
      </ul>

      <button class="primary mt-0 mb-4 m-2 text-small d-none">Save</button>

      <ul class=" mt-1 mb-1">
        <li>
          <a href="#" target="_blank" class="text-nodec text-black"
            @click="updatePictures">
            <span>
              Pictures
              <span class="ml-auto"><v-icon name="images"/></span>
            </span>
          </a>
        </li>
      </ul>

      <p class="text-pink text-bold text-smaller mt-5 ph-3">DISCOVERY SETTINGS</p>

      <ul class="mt-1 mb-4">
        <li>
          <div class="d-flex flex-row flex-jc-start">
            <span>
              I am
            </span>
            <select class="flex-1 text-right ml-auto" v-model="sex">
              <option v-for="op of ['Male', 'Female', 'Other']" :key="op">
                {{ op }}
              </option>
            </select>
          </div>
        </li>
        <li>
          <div class="d-flex flex-row flex-jc-start">
            <span>
              Looking for
            </span>
            <select class="flex-1 text-right ml-auto" v-model="sexualPreference">
              <option v-for="op of sexualPreferences" :key="op[0]"
                :value="op[1]">
                {{ op[0] }}
              </option>
            </select>
          </div>
        </li>
        <li>
          <span>
            First name
            <input :placeholder="user.name.first" v-model="name.first" class="flex-1 text-right" />
          </span>
        </li>
        <li>
          <span>
            Last name
            <input :placeholder="user.name.last" v-model="name.last" class="flex-1 text-right" />
          </span>
        </li>
        <li>
          <span>
            Bio
            <input :placeholder="user.bio" v-model="bio" class="flex-1 text-right" />
          </span>
        </li>
      </ul>

      <AsyncButton class="primary mv-5 mh-auto" :fn="updateInformation">
        Update information
      </AsyncButton>
    </form>

    <p class="text-pink text-bold text-smaller mv-2 ph-3">LEGAL</p>

    <ul class="mt-1 mb-4">
      <li>
        <a href="/terms.txt" target="_blank" class="text-nodec text-black">
          <span>
            Terms of Service
            <span class="ml-auto"><v-icon name="external-link-alt"/></span>
          </span>
        </a>
      </li>
      <li>
        <a target="_blank" class="text-nodec text-muted">
          <span>
            Cookie Policy
            <span class="ml-auto"><v-icon name="external-link-alt"/></span>
          </span>
        </a>
      </li>
    </ul>

    <!-- <button @click="$bus.$emit('logout')" class="mb-4">Logout</button> -->

    <ul class="mb-4">
      <li class="text-center pointer pv-2" @click="share">
        {{ shareMsg }}
      </li>
    </ul>

    <ul class="mb-4">
      <li class="text-center pointer" @click="$bus.$emit('logout')">
        Logout
      </li>
    </ul>

    <img src="/favicon.ico" width="24" class="mh-auto mv-1">
    <small class="d-block text-center">Version 1.0.0</small>

    <ul class="mt-4">
      <li class="text-muted text-center">
        Delete Account
      </li>
    </ul>

    <PopupContainer v-if="showUpdatePictures" show :canClose="false">
      <div class="d-flex flex-col text-dark bg-white ph-2 pv-5 card
        min-h-content max-w-100">
        <!-- .d-flex.flex-row. -->
        <button class="popup-close">
          <v-icon name="times"/>
        </button>

        <ImageChooser :images.sync="images" :uploading="uploading" :error.sync="uploadError"
          @cancel="showUpdatePictures = false" @done="uploadPictures"/>
      </div>
    </PopupContainer>
  </div>
</template>

<script>
import { mapState } from 'vuex';
// import ToggleInput from '@/components/ToggleInput.vue';
import PopupContainer from '@/components/PopupContainer.vue';
import ImageChooser from '@/components/ImageChooser.vue';
import axios from 'axios';
import AsyncButton from '@/components/AsyncButton.vue';
import Vue from 'vue';
// add data information to store inputs
export default {
  data: () => ({
    shareMsg: 'Share Matcha',
    changePass: false,

    showUpdatePictures: false,
    uploadError: null,
    uploading: false,
    images: [],

    shareTO: null,

    updatingInfoError: null,

    sexualPreferences: [
      ['Man', 'male'],
      ['Woman', 'female'],
      ['Both', 'both'],
      ['Other', 'other'],
    ],

    username: '',
    name: {
      first: '',
      last: ''
    },
    email_notify: false,
    location_enabled: false,
    sex: '',
    sexualPreference: '',
    bio: '',
    email: '',
    oldPassword: '',
    newPassword: ''
  }),
  computed: {
    ...mapState(['user']),
  },
  components: {
    // ToggleInput,
    ImageChooser,
    PopupContainer,
    AsyncButton
  },
  methods: {
    share() {
      let text = `Check out Matcha... it shows who likes you nearby ` +
                  (new URL(window.location)).origin;
      navigator.clipboard.writeText(text)
        .then(() => {
          this.shareMsg = 'Text copied to clipboard';

          if (this.shareTO) clearTimeout(this.shareTO);
          this.shareTO = setTimeout(() => {
            this.shareMsg = 'Share Matcha';
            this.shareTO = null;
          }, 5000);
        })
        .catch(() => window.alert(text));
    },
    updatePictures(e) {
      e.preventDefault();

      this.images = [ ...this.user.media ];
      this.showUpdatePictures = true;
    },
    async uploadPictures() {
      try {
        // let toUpload = this.images.filter((i) => i.startsWith('data'));
        let _images = new Array(this.images.length);
        this.uploadError = null;

        await Promise.all(this.images.map((img, i) => {
          if (!img.startsWith('data')) {
            _images[i] = img;
            return true;
          }

          return (async () => {
            this.uploading = true;
            let { data } = await axios.post('/api/user/upload_picture', {
              picture: img,
            });
            _images[i] = data.url;
          })();
        }));

        let { data } = await axios.post('/api/user/update', { media: _images });

        this.$store.commit('setUser', data);
        this.showUpdatePictures = false;
      }
      catch(e) {
        e;
        if (e.response)
          this.uploadError = e.response.data.error;
      }
      this.uploading = false;
    },
    async updateInformation (e) {
      e.preventDefault();
      this.updatingInfoError = null;
      let payload = {};

      if (this.changePass) {
        if (!(this.oldPassword && this.newPassword))
          return this.updatingInfoError = 'Password is required';
        if (this.oldPassword === this.newPassword)
          return this.updatingInfoError = 'New password is the same as old';
        // Append passwords to payload
        payload.oldPassword = this.oldPassword;
        payload.newPassword = this.newPassword;
      }

      if (this.email && this.email != this.user.email)
        payload.email = this.email;

      if (this.username && this.username != this.user.username)
        payload.username = this.username;

      if (this.email_notify != this.user.settings.email_notify)
        payload['settings.email_notify'] = this.email_notify;

      if (this.location_enabled != this.user.settings.location_enabled)
        payload['settings.location_enabled'] = this.location_enabled;

      if (this.sex && this.sex.toLowerCase() != this.user.sex)
        payload.sex = this.sex.toLowerCase();

      if (this.sexualPreference &&
          this.sexualPreference != this.user.sexualPreference)
        payload.sexualPreference = this.sexualPreference;

      if (this.bio && this.bio != this.user.bio)
        payload.bio = this.bio;

      if (this.name.first && this.name.first != this.user.name.first)
        payload['name.first'] = this.name.first;

      if (this.name.last && this.name.last != this.user.name.last)
        payload['name.last'] = this.name.last;

      if (Object.keys(payload).length == 0)
        return ;

      try {
        let { data: user } = await axios.post('/api/user/update', payload);
        alert('Information updated.');
        Vue.set(this.$store.state, 'user', user);
      } catch(err) {
        if (err.response) {
          this.updatingInfoError = err.response.data.error;
        }
        else
          err;
      }
    }
  },
  mounted() {
    this.email_notify = this.user.settings.email_notify;
    this.location_enabled = this.user.settings.location_enabled;
  },
};
</script>

<style scoped>

ul {
  margin: 0;
  padding: 0;
  background: white;
}

ul li {
  list-style: none;
  min-height: 40px;

  display: flex;
  flex-direction: column;
  justify-content: center;

  padding: .75em 1em;
  border-top: 1px solid #e0e4e9;
}

ul li:last-child {
  border-bottom: 1px solid #e0e4e9;
}

ul li span {
  display: flex;
  flex-direction: row;
  align-items: center;
}

ul li:hover a[href] .fa-icon {
  color: var(--color-pink) !important;
}

select {
  max-width: 50%;
  margin-left: auto;
}

input {
  min-width: 0;
  border: 0;
  /* max-width: 50%; */
}

</style>
